<?php

namespace tmc\revisionmanager\src\AdminPages\PageSettings;

use shellpress\v1_3_84\src\Shared\AdminPageFramework\AdminPageTab;
use tmc\revisionmanager\src\App;

/**
 * @author jakubkuranda@gmail.com
 * Date: 20.02.2020
 * Time: 12:44
 */
class TabLicense extends AdminPageTab {

	/**
	 * Declaration of current element.
	 */
	public function setUp() {

		//  ----------------------------------------
		//  Definition
		//  ----------------------------------------

		$this->pageFactory->addInPageTab(
			array(
				'page_slug'     =>  $this->pageSlug,
				'tab_slug'      =>  $this->tabSlug,
				'title'         =>  __( 'License', 'rm_tmc' ),
			)
		);

	}

	/**
	 * Called while current component is loaded.
	 */
	public function load() {

		//  ----------------------------------------
		//  Sections
		//  ----------------------------------------

		$this->pageFactory->addSettingSections(
			array(
				'section_id'            =>  'license',
				'page_slug'             =>  $this->pageSlug,
				'tab_slug'              =>  $this->tabSlug,
				'order'                 =>  10,
				'title'                 =>  __( 'License', 'rm_tmc' ),
				'content'               =>  App::i()->license->getDisplay(),
				'description'           =>  array(
					__( 'You can use premium features and extended support.', 'rm_tmc' ),
					__( 'Some features require external server to provide seamless functionality.', 'rm_tmc' ),
					__( 'You can activate and deactivate your license here and move it between different installations.', 'rm_tmc' )
				)
			)
		);

	}

}